indexing
   title:       "Yet Another DATE_TIME demo";
   cluster:     "timedate/examples/test_doc [timedate/examples/test_doc]";
   project:     "The Universal Time & Date UTDC";
   copyright:   "SIG Computer, 1995";
   author:      "Alexei Simonov (alex@eiffel.ru)";
   original:    22,Sep,95;
   version:     1.0;
   done_at:     "SIG Computer (info@eiffel.ru)";
   license:     "GNU Library GPL - see included readme file";
   extrnl_name: "test_doc.e";

class TEST_DOCUMENT

   creation
      make

   feature

      make is
         local
            a, b, c: TIMESTAMP
            dl: LONG_DURATION
            d,e: DURATION
            t: TIME_TOOLS
            i: INTEGER
            da, db: DATE
            xl: LONG_DURATION
            f : SCIENTIFIC_FORMAT
         do
            !!f.make
            !! b.set_to_now;                    -- today

            f.printf("Today is !a, !t%N", << b, b >> )
            f.printf("!i years, !i months, !i days, ",
                   << b.year_part, b.month_part, b.day_part >> )
            f.printf("!i hours, !i minutes, !f seconds.%N",
                   << b.hour_part, b.minute_part, b.second_part >> )

            !! t
            f.printf ("Today is !s %N", << t.day_name (b.day_of_week)>> );

            !! a.set (b.year_part, 1, 1, 0, 0, 0);  -- begin of this year
            f.printf("Begin of this year was is !a, !t%N", << a, a >> )

            d := b.difference (a);             -- calculate duration

            f.printf("Elapsed !10.3f minutes%N", << d.as_minutes >> )
            f.printf("Elapsed !10.3f hours%N", << d.as_hours >> )
            f.printf("Elapsed !10.3f days%N", << d.as_days >> )

            --
            !! d.set_from_compressed (7, 0);   -- one week
            f.printf("After week will be !a%N", << b.plus (d) >> )
            f.printf("After four week will be !a%N", << b.plus (d.multiply_by (4)) >> )
            --
            -- measures some activities
            !! a.set_to_now
            f.print("Moment A%N")
            -- ..
            -- do first activity (x seconds)
            !! b.set_to_now
            f.print("Moment B%N")
            -- ..
            -- do second activity (y seconds)
            !! c.set_to_now
            f.print("Moment C%N")

            d := b.difference (a);
            e := c.difference (b);

            --
            -- another way to calculate the difference between
            -- two DATES
            !! da.set_date (1996, 7, 13);
            !! db.set_date (1995, 7, 13);
            i := da.absolute_days - db.absolute_days;
            f.print ( i )

       end -- make

   end --  class TEST_DOCUMENT

